package ca.gc.nrc.iit.pds.appgui.simulation;

import java.io.File;
import java.util.ArrayList;

import javax.swing.filechooser.FileFilter;

/**
 * CDppFileFilter class filters file from a filechooser
 * @author jchazal
 *
 */
public class CDppFileFilter extends FileFilter {

	/**
	 * The file description
	 */
	private String description;
	
	/**
	 * File extensions allowed
	 */
	private ArrayList<String> extensions;
	
	/**
	 * Default contructor. Buid a new list of extensions
	 */
	public CDppFileFilter(){
		this.extensions = new ArrayList<String>();
	}
		
	public boolean accept(File file) {
		
		if(file.isDirectory() || extensions.size()==0) {
			return true;
		}
		String fileName = file.getName().toLowerCase(); 
		for(String extension : extensions){
			if(fileName.endsWith(extension)){
	            return true;
	        }
	    }
	    return false;
	}

	public String getDescription() {
		if(description != null){
			StringBuffer buffer = new StringBuffer(description);
		    buffer.append(" (");
		    for(String extension : extensions){
		       buffer.append(extension).append(" ");
		    }
		    return buffer.append(")").toString();
		}
		else return null;
	}
	
	public void addExtension(String ext){
		if(ext == null){
			throw new NullPointerException("File extension can't be null!!!");
		}
		extensions.add(ext);
	}
	
	public void clear(){
		extensions.clear();
		description = "";
	}
	
	public void setDescription(String desc){
		if(desc == null){
			throw new NullPointerException("File extension description can't be null!!!");
		}
		this.description = desc;
	}
}
