/*******************************************************
*
*  DESCRIPTION: CD++ compiler for Modelica specifications 
*
*  AUTHOR: Mariana C. D'Abreu
*
*  EMAIL: mdabreu@dc.uba.ar
*
********************************************************/

#ifndef MODELICA_COMPILER
#define MODELICA_COMPILER

#include <string>
#include "ini.h"
#include "modparser.h"
#include "bgmapper.h"
#include "cdppcompiler.h"
#include "modexcept.h"


class Modelica2CDPPCompiler 
{
  public:

    Modelica2CDPPCompiler( int argc, const char *argv[] );
    ~Modelica2CDPPCompiler();

    int compile();

  private:

    Modelica2CDPPCompiler &setCDPPCompilerParams();
    void printUsage( const string &pgm ) const;

    string	simParamsFile;  	
    string 	outDir;
    RealValue   gQuantum;
    RealValue   gHystWind;

    EC_BG_Mapper *mapper;	  // Electrical circuit to Bond Graph mapper
    BG_CDPP_Compiler *compiler;   // Bond Graph to CD++ compiler

};


#endif
