/*******************************************************************
*
*  DESCRIPTION: Simulator::registerNewAtomics()
*
*******************************************************************/

#include "modeladm.h" 
#include "mainsimu.h"
#include "qbg_resistance_ei.h"
#include "qbg_resistance_fi.h"
#include "qbg_source.h"
#include "qbg_sjunc.h"
#include "qbg_pjunc.h"
#include "qbg_capacitor_fi.h"
#include "qbg_inductor_ei.h"
#include "qbg_transformer.h"
#include "qbg_gyrator_ei.h"
#include "qbg_gyrator_fi.h"


void MainSimulator::registerNewAtomics()
{
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGResistanceEffortIn>(), "QBGResistanceEffortIn" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGResistanceFlowIn>(), "QBGResistanceFlowIn" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGSourceEffort_Constant>(), "QBGSourceEffort_Constant" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGSourceFlow_Constant>(), "QBGSourceFlow_Constant" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGSourceEffort_Step>(), "QBGSourceEffort_Step" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGSourceFlow_Step>(), "QBGSourceFlow_Step" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGSourceEffort_Sine>(), "QBGSourceEffort_Sine" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGSourceFlow_Sine>(), "QBGSourceFlow_Sine" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGSourceEffort_Pulse>(), "QBGSourceEffort_Pulse" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGSourceFlow_Pulse>(), "QBGSourceFlow_Pulse" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGSerialJunction>(), "QBGSerialJunction" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGParallelJunction>(), "QBGParallelJunction" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGCapacitorFlowIn>(), "QBGCapacitorFlowIn" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGInductorEffortIn>(), "QBGInductorEffortIn" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGTransformer>(), "QBGTransformer" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGGyratorEffortIn>(), "QBGGyratorEffortIn" ) ;
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<QBGGyratorFlowIn>(), "QBGGyratorFlowIn" ) ;
}
