package CDBuilder.buttons;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.runtime.IPath;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PlatformUI;

import CDBuilder.console.ConsoleDocument;

public class SimServiceAction extends Action implements IWorkbenchWindowActionDelegate{

	public SimServiceAction() {
		super();
	}

	public void dispose() {
		
	}

	public void init(IWorkbenchWindow window) {
		 
	}

	public void run(IAction action) {
		try {
			//Console view
			PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().showView("ConsoleView");
			//gets the active page								
			IWorkspaceRoot root =(IWorkspaceRoot)PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getInput();
			//get path
			IPath projectPath = root.getLocation();
			
			// gets the path where the program is
			IPath guiPath = root.getLocation().removeLastSegments(1);
			
			guiPath = guiPath.append("/plugins/CD++Builder_1.1.0/SimServiceGUI/");
			
			//All the .jar files are needed
			Process simServiceProcess = Runtime.getRuntime().exec(
					"java -classpath \"" + guiPath+ "SimServiceGUI.jar\";" + 
					"\"" + guiPath + "SimulationService.jar\";" + 
					"\"" + guiPath + "activation.jar\";" + 
					"\"" + guiPath + "com.jar\";" + 
					"\"" + guiPath + "org.jar\";" + 
					"\"" + guiPath + "javax.jar\";" + 
					"\"" + guiPath + "images.jar\";" +
					"\"" + guiPath + "axis-ant.jar\";" + 
					"\"" + guiPath + "axis-schema.jar\";" + 
					"\"" + guiPath + "axis.jar\";" + 
					"\"" + guiPath + "commons-discovery-0.2.jar\";" + 
					"\"" + guiPath + "commons-logging-1.0.4.jar\";" + 
					"\"" + guiPath + "jaxrpc.jar\";" + 
					"\"" + guiPath + "log4j-1.2.8.jar\";" + 
					"\"" + guiPath + "mail.jar\";" + 
					"\"" + guiPath + "saaj.jar\";" + 
					"\"" + guiPath + "wsdl4j-1.5.1.jar\"" + 
					" ca.gc.nrc.iit.pds.appgui.simulation.Client",null,new File(guiPath.toString()));
			BufferedReader run_error = new BufferedReader(new InputStreamReader(simServiceProcess.getErrorStream()));
			StringBuilder strB = new StringBuilder("");
			int c1 = -1;
			while ( (c1=run_error.read()) != -1)
			{
				strB.append((char) c1) ; 
			}
			run_error.close();
			
			if(strB.length() > 0){				
				ConsoleDocument.getCDOS().set(strB.toString());
			}				
			run_error.close();

		} catch (Exception e) {
			e.printStackTrace();
			MessageBox mb = new MessageBox(new Shell(),SWT.RETRY | SWT.ICON_ERROR | SWT.APPLICATION_MODAL);
			mb.setText("Simulation Service GUI Program Not Found");
			mb.setMessage("Workspace directory must be place in eclipse directory (like C:\\eclipse\\workspace)!!!");
			mb.open();
			
			try {
				mb.wait();
			} catch (InterruptedException e1) {
			
			}
		}
		
	}

	public void selectionChanged(IAction action, ISelection selection) {

	}
}
