/*
 * Created on Jun 20, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package CDBuilder.buttons;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.runtime.IPath;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PlatformUI;

import CDBuilder.console.ConsoleDocument;




/**
 * @author ssim
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class SimuAction extends Action implements IWorkbenchWindowActionDelegate{
	IContainer container;
	boolean isCellDev;
	
	public SimuAction() {
		super();
		setText("Simulate");
		setDescription("This is a Simulator");

	}
	
	public void run() {
		boolean needCompile;
		isCellDev = true;// is true always unless a .cpp file is found
		
		try {
			//show console view
			PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().showView("ConsoleView");
			ConsoleDocument cdos = ConsoleDocument.getCDOS();
			IWorkspaceRoot root = (IWorkspaceRoot)PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getInput();
			//get path
			IPath projectPath = root.getLocation();
			
			String selectPath = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getSelectionService().getSelection(IPageLayout.ID_RES_NAV).toString();
			selectPath = selectPath.substring(selectPath.indexOf("/")+1, selectPath.lastIndexOf("/")); //concatenate the string to get rid of []
			projectPath = projectPath.append(selectPath +"/");
			System.out.println("Project Path:" + projectPath);
	
			IPath internalPath = root.getLocation().removeLastSegments(1);
			internalPath = internalPath.append("/plugins/CD++Builder_1.1.0/internal/");
			System.out.println("Internal Path: " + internalPath);
			
			IContainer container = root.getContainerForLocation(projectPath);
			String projectPathForUnix = projectPath.toString().charAt(0) + projectPath.toString().substring(2);
			String internalPathForUnix = internalPath.toString().charAt(0) + internalPath.toString().substring(2);

			Shell parent = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();
			File simuFileCheck = new File(projectPath + "simu.exe");

		//	cdos.clear();
			container.refreshLocal(1, null);
			try {
				IResource[] projectFiles;
				projectFiles = root.getContainerForLocation(projectPath).members();
				IFile maFile = null;
				for(int i=0;i<projectFiles.length;i++){
					if(projectFiles[i] instanceof IFile && (projectFiles[i].getName().toUpperCase().endsWith(".MA"))){
						maFile=(IFile) projectFiles[i];
					}else if(projectFiles[i]instanceof IFile && ( projectFiles[i].getName().endsWith(".CPP") || projectFiles[i].getName().endsWith(".cpp") )){
						isCellDev = false;	// is true always unless a .cpp file is found
					}
				}

				if (!simuFileCheck.exists()) {

					FileReader register = new FileReader(internalPath.append("register.cpp").toFile());
					root.getFileForLocation(internalPath.append("register.cpp"));
					
					String line;
					ArrayList typeFiles= new ArrayList();
				

					if (maFile == null){
						
						MessageBox noMA = new MessageBox(parent, SWT.ICON_ERROR | SWT.OK);
						noMA.setMessage("Ma file not found in project");
						noMA.setText("File Not Found");
						noMA.open();
						return;
									
					}	
					
					BufferedReader br= new BufferedReader(register);
				
					while ((line=br.readLine()) != null) {
						
						if(line.indexOf("NewAtomicFunction")!=-1){
							typeFiles.add(line.substring(line.indexOf('"')+1,line.lastIndexOf('"')));
						}
									
					}
					typeFiles.add("ggad");
													
					InputStream is= maFile.getContents();
					br= new BufferedReader(new InputStreamReader(is));
				
					while ((line=br.readLine()) != null) {
						if(line.trim().startsWith("components")){
							
							int currentIndex=0;
							int lastIndex=line.lastIndexOf("@");
							String type;
							if (lastIndex==-1)
								continue;
							
							//to get the last type.
							line=line.concat(" ");
							while(currentIndex!=lastIndex){
								needCompile=true;
								currentIndex=line.indexOf("@",currentIndex+1);
								type=line.substring(currentIndex+1,line.indexOf(" ",currentIndex));
								for(int i=0;i<typeFiles.size();i++){
									if(type.equalsIgnoreCase((String)typeFiles.get(i))){
										System.out.println(type);
										System.out.println(typeFiles.get(i));
										needCompile=false;
										break;
									}
								}
								if (needCompile)
									throw new Exception();
							}
						}
					}
	
									
					/*Process moveSimuProc = Runtime.getRuntime().exec("cp "+ internalPath +"simuOrig.exe "+ projectPath + "simu.exe");	
					StreamHandler rmDerrorHandler = new StreamHandler(moveSimuProc.getErrorStream(), "ERROR",true);            
					StreamHandler rmDoutputHandler = new StreamHandler(moveSimuProc.getInputStream(), "OUTPUT", true);
					rmDerrorHandler.start();
					rmDoutputHandler.start();*/
	
				}//end of if (simu.exists())
			} catch (Exception e1) {
				e1.printStackTrace();
				MessageBox noSimu = new MessageBox(parent, SWT.ICON_ERROR | SWT.OK);
				noSimu.setMessage("The Simulation executable was not found, please compile the project");
				noSimu.setText("simu.exe Not Found");
				noSimu.open();
				return;
			}			
			
			SimuGui dialog = new SimuGui(parent, projectPath, isCellDev, internalPath);
			dialog.create();
			dialog.open();
			dialog.close();
			container.refreshLocal(1, null);
			
		}catch (Exception np) {
				MessageBox npGui = new MessageBox(new Shell(), SWT.ICON_ERROR | SWT.OK);
				npGui.setMessage("You must select a file or project folder to start simulations! ");
				npGui.setText("Project Not Selected");
				npGui.open();
				ConsoleDocument.getCDOS().set("Please select a project or folder from the navigator.");
		}
				
	}
	
	public void run(IAction action) {
		run();
	}
	
	public void dispose() {
		// do nothing.
	}
	
	public void init(IWorkbenchWindow window) {
		// do nothing.
	}
	
	public void selectionChanged(IAction action, ISelection selection) {

	}
	
}





