package CDBuilder.buttons;


 
import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;

import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import CDBuilder.console.ConsoleDocument;
import CDBuilder.console.StreamHandler;

/**
 * @author K. Omair Muhi
 * RADS lab
 * Carleton University
 * Ottawa,ON,Canada
 * 
 * @version 1.0 May 31, 2005
 */
public class SimuModelicaGUI extends Dialog {
	
	//private instance variables
	private Shell parent;
	private Composite composite;
	private Process simuProcess;
	private String title;
	private String messageRoot;
	private String message;
	private String message1;
	private String message2;
	private String message3;
	private String message4;
	private String message5;
	private String message6;
	private String message7;
	private String moFile;
	private String logFile;
	private String configFile;
	private String outDir;
	private Text textRoot;
	private Text textMo;
	private Text textLog; 
	private Text textConfig;
	private Text textOutDir;
	private Text textTime1;
	private Text textTime2;
	private Text textTime3;
	private Text textTime4;
	private Text textWidth;
	private Text textPrecision;
	private Text textHyst;
	private Text textQntm;
	private Button fileButtonRoot;
	private Button fileButtonMo;
	private Button fileButtonLog;
	private Button fileButtonConfig;
	private Button fileButtonOutDir; 
	private Button simuButton;
	private Button killButton;
	private Button doneButton;
	/*determines if the window is closeable*/
	private boolean ok2Close;
	private boolean simuKilled;
	private boolean isFieldEmpty=false;
	private Process runCygwin; 
	
	
	//private instance variables
	
	//public constructor
	public SimuModelicaGUI(Shell parentShell){
		super(parentShell);
		parent = parentShell;
		this.title = "Simulate Modelica *.mo file";
		messageRoot = "Select Eclipse root folder";
		message  = "Select Modelica (*.mo) file";
		message1 = "Select output (log) file";
		message2 = "Select configuration file";
		message3 = "Select output directory";
		message4 = "Enter simulation stop time (hours:minutes:seconds:milliseconds):";
		message5 = "Enter W-idth and P-recision (form WW-PP) for showing numbers";
		message6 = "Enter simulator general hysteresis window";
		message7 = "Enter simulator general quantum";
		ok2Close = true;
	}
//	public constructor


	protected void configureShell(Shell shell){
		super.configureShell(shell);
		//the following line registers the shell of SimuGui to parent
		//which causes the file-dialog box modal to the SimuGui dialog
		//this fixes the problem associated with the file-dialog not being modal to SimuGui 
		parent = shell;
		if (title != null)
			shell.setText(title);
		
	}
	
	protected Control createDialogArea(Composite parent){
		
		composite = (Composite)super.createDialogArea(parent);
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 10;
		composite.setLayout(gridLayout);
		
		//Creates label for textMo
		Label label = createLabel(parent,composite,messageRoot);
		GridData griddata = new GridData();
		griddata.horizontalAlignment = GridData.FILL;
		griddata.horizontalSpan = 10;
		label.setLayoutData(griddata);		
		label.setFont(parent.getFont());
		
		//Creates a text box for the eclipse root folder
		//and sets its positional attributes
		textRoot = new Text(composite,SWT.SINGLE | SWT.BORDER);
		textRoot.setEditable(true);
		Color c = new Color(null,255,255,255);
		textRoot.setBackground(c);
		GridData gridDataRoot = new GridData();
		gridDataRoot.horizontalSpan = 9;
		gridDataRoot.widthHint = convertHorizontalDLUsToPixels(IDialogConstants.MINIMUM_MESSAGE_AREA_WIDTH);
		textRoot.setLayoutData(gridDataRoot);

		//Creates fileButton for textRoot
		fileButtonRoot = new Button (composite,SWT.PUSH);
		fileButtonRoot.setText("Browse");
		fileButtonRoot.setToolTipText("Select *.mo file");
		GridData gridDataFBRoot = new GridData();
		fileButtonRoot.setLayoutData(gridDataFBRoot);
		fileButtonRoot.addSelectionListener(new SelectionAdapter(){
		
			public void widgetSelected(SelectionEvent e){
				String dirName = newDirGui();
				if (!dirName.equals(""))
				textRoot.setText( dirName );
			}
		});
		
		//Creates label for textMo				
		label = createLabel(parent,composite,message);
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.horizontalSpan = 10;
		label.setLayoutData(gridData);
		label.setFont(parent.getFont());
		
		//Creates a text box for the *.mo file
		//and sets its positional attributes
		textMo = new Text(composite,SWT.SINGLE | SWT.BORDER);
		textMo.setEditable(false);
		textMo.setBackground(c);
		GridData gridDataMo = new GridData();
		gridDataMo.horizontalSpan = 9;
		gridDataMo.widthHint = convertHorizontalDLUsToPixels(IDialogConstants.MINIMUM_MESSAGE_AREA_WIDTH);
		textMo.setLayoutData(gridDataMo);
		
		//Creates the *.mo file Browse button and sets its positional attributes
		fileButtonMo = new Button (composite,SWT.PUSH);
		fileButtonMo.setText("Browse");
		fileButtonMo.setToolTipText("Select *.mo file");
		GridData gridDataFBMo = new GridData();
		fileButtonMo.setLayoutData(gridDataFBMo);
		fileButtonMo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e){
				
			String fileName = NewFileGui("*.mo");
			String temp = fileName.substring(fileName.lastIndexOf("\\")+1);
			if (!temp.equals(""))
			textMo.setText( fileName);
			}
		});

		
		/*GUI related to log file*/
		//Creates a label for log file to be output
		label  = createLabel(parent,composite,message1);
		GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.horizontalSpan = 10;
		label.setLayoutData(gridData1);
		label.setFont(parent.getFont());
			
		//Create a checkbox for default selection
		//chkBxLog = new Button(composite,SWT.CHECK);

		
		//Creates a text box for the log file
		//and sets its positional attributes
		textLog = new Text(composite, SWT.SINGLE | SWT.BORDER);
		textLog.setEditable(false);
		textLog.setBackground(c);
		GridData gridData2 = new GridData();
		gridData2.horizontalSpan=9;
		gridData2.widthHint = convertHorizontalDLUsToPixels(IDialogConstants.MINIMUM_MESSAGE_AREA_WIDTH);
		textLog.setLayoutData(gridData2);
		
		//Creates the log file Browse button and sets its positional attributes
		fileButtonLog = new Button (composite,SWT.PUSH);
		fileButtonLog.setText("Browse");
				fileButtonLog.setToolTipText("Select log File");
				GridData gridDataFBLog = new GridData();
				fileButtonLog.setLayoutData(gridDataFBLog);
				fileButtonLog.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent e){
				
					String fileName = NewFileGui("*.log");
					String temp = fileName.substring(fileName.lastIndexOf("\\")+1);
					if (!temp.equals(""))
					textLog.setText( fileName);
					}
				});
		
		/*GUI related to configuration file*/
		//Create label for configuration file
		label = createLabel(parent,composite,message2);
		
		//Create text box for configuration file
		textConfig = new Text(composite, SWT.SINGLE | SWT.BORDER);
		textConfig.setEditable(false);
		textConfig.setBackground( c );
		GridData gridData3 = new GridData();
		gridData3.horizontalSpan = 9;
		gridData3.grabExcessHorizontalSpace = true;
		gridData3.widthHint = convertHorizontalDLUsToPixels(IDialogConstants.MINIMUM_MESSAGE_AREA_WIDTH);
		textConfig.setLayoutData( gridData3 );

		//Create browse button for configuration fiel
		fileButtonConfig = new Button(composite,SWT.PUSH);
		fileButtonConfig.setText( "Browse" );
		fileButtonConfig.setToolTipText( "Select configuration file" );
		GridData gridDataFBConfig = new GridData();
		gridDataFBConfig.horizontalAlignment = GridData.BEGINNING;
		fileButtonConfig.setLayoutData( gridDataFBConfig );
		fileButtonConfig.addSelectionListener( new SelectionAdapter() {
			public void widgetSelected( SelectionEvent e ){
			String fileName = NewFileGui( "*.txt" );
			String temp = fileName.substring(fileName.lastIndexOf("\\")+1);
			if (!temp.equals(""))
			textConfig.setText( fileName );
			}
		});		

		/*GUI related to output directory*/
		//Create label for output directory
		label = createLabel(parent,composite,message3);
		
		//Create textBox for output directory
		textOutDir = new Text(composite, SWT.SINGLE | SWT.BORDER);
		textOutDir.setEditable(false);
		textOutDir.setBackground(c);
		GridData gridData4 = new GridData();
		gridData4.horizontalSpan = 9;
		gridData4.grabExcessHorizontalSpace = true;
		gridData4.widthHint = convertHorizontalDLUsToPixels(IDialogConstants.MINIMUM_MESSAGE_AREA_WIDTH);
		textOutDir.setLayoutData( gridData4 );
		
		//Create browse button for output directory
		fileButtonOutDir = new Button(composite,SWT.PUSH);
		fileButtonOutDir.setText( "Browse" );
		fileButtonOutDir.setToolTipText( "Select output directory" );
		GridData gridDataFBOut = new GridData();
		gridDataFBOut.horizontalAlignment = GridData.BEGINNING;
		fileButtonOutDir.setLayoutData( gridDataFBOut );
		fileButtonOutDir.addSelectionListener( new SelectionAdapter() {
			public void widgetSelected( SelectionEvent e ){
			String dirName = newDirGui();
			if (!dirName.equals(""))
			textOutDir.setText( dirName );
			}
		});	
		/*GUI related to time*/
		//Create label for timeBar
		label = new Label(composite, SWT.WRAP);
		label.setText(message4);
		GridData gridData5 = new GridData();
		gridData5.horizontalAlignment = GridData.BEGINNING;
		gridData5.horizontalSpan = 10;
		label.setLayoutData(gridData5);
		label.setFont(parent.getFont());
		
		//Create textBox for Hours and for the first colon
		textTime1 = new Text(composite, SWT.SINGLE | SWT.BORDER);
		textTime1.setTextLimit(2);
		

		GridData gridData6 = new GridData();
		gridData6.widthHint = 15;
		gridData6.heightHint = 13;
		textTime1.setLayoutData(gridData6);
		textTime1.setToolTipText("Hours");
		textTime1.setText("00");
		textTime1.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent e) {
				try {
					Integer time = new Integer(textTime1.getText());
					if (e.keyCode == SWT.ARROW_UP) {
						time = new Integer(time.intValue() + 1);
						if (time.intValue() > 99) {
							textTime1.setText("00");
						} else {
							textTime1.setText(time.toString());
						}
					}

					if (e.keyCode == SWT.ARROW_DOWN) {
						time = new Integer(time.intValue() - 1);
						if (time.intValue() < 0) {
							textTime1.setText("99");
						} else {
							textTime1.setText(time.toString());
						}
					}
				} catch (NumberFormatException e2) {
					textTime1.setText("");
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}

			public void keyReleased(KeyEvent e) {

			}
		});

		Label colon1 = new Label(composite, SWT.NONE);
		colon1.setText(":");	

		//Create textBox for minutes and for colon #2
		textTime2 = new Text(composite, SWT.SINGLE | SWT.BORDER);
		textTime2.setTextLimit(2);
		GridData gridData7 = new GridData();
		gridData7.widthHint = 15;
		gridData7.heightHint = 13;
		textTime2.setLayoutData(gridData7);
		textTime2.setToolTipText("Minutes");
		textTime2.setText("00");
		textTime2.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent e) {
				try {
					Integer time = new Integer(textTime2.getText());
					if (e.keyCode == SWT.ARROW_UP) {
						time = new Integer(time.intValue() + 1);
						if (time.intValue() > 99) {
							textTime2.setText("00");
						} else {
							textTime2.setText(time.toString());
						}
					}

					if (e.keyCode == SWT.ARROW_DOWN) {
						time = new Integer(time.intValue() - 1);
						if (time.intValue() < 0) {
							textTime2.setText("99");
						} else {
							textTime2.setText(time.toString());
						}
					}
				} catch (NumberFormatException e2) {
					textTime2.setText("");
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
			public void keyReleased(KeyEvent e) {

			}
		});
		Label colon2 = new Label(composite, SWT.NONE);
		colon2.setText(":");
		
		//Create textBox for seconds and for colon #3
		textTime3 = new Text(composite, SWT.SINGLE | SWT.BORDER);
		textTime3.setTextLimit(2);
		GridData gridData8 = new GridData();
		gridData8.widthHint = 15;
		gridData8.heightHint = 13;
		textTime3.setLayoutData(gridData8);
		textTime3.setToolTipText("Seconds");
		textTime3.setText("00");
		textTime3.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent e) {
				try {
					Integer time = new Integer(textTime3.getText());
					if (e.keyCode == SWT.ARROW_UP) {
						time = new Integer(time.intValue() + 1);
						if (time.intValue() > 99) {
							textTime3.setText("00");
						} else {
							textTime3.setText(time.toString());
						}
					}

					if (e.keyCode == SWT.ARROW_DOWN) {
						time = new Integer(time.intValue() - 1);
						if (time.intValue() < 0) {
							textTime3.setText("99");
						} else {
							textTime3.setText(time.toString());
						}
					}
				} catch (NumberFormatException e2) {
					textTime3.setText("");
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}

			public void keyReleased(KeyEvent e) {

			}
		});
		Label colon3 = new Label(composite, SWT.NONE);
		colon3.setText(":");
		
		//Create textBox for milliseconds
		textTime4 = new Text(composite, SWT.SINGLE | SWT.BORDER);
		textTime4.setTextLimit(3);
		textTime4.setText("000");
		GridData gridData9 = new GridData();
		gridData9.widthHint = 20;
		gridData9.heightHint = 13;
		textTime4.setLayoutData(gridData9);
		textTime4.setToolTipText("Milliseconds");
		textTime4.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent e) {
				try {
					Integer time = new Integer(textTime4.getText());
					if (e.keyCode == SWT.ARROW_UP) {
						time = new Integer(time.intValue() + 1);
						if (time.intValue() > 999) {
							textTime4.setText("000");
						} else {
							textTime4.setText(time.toString());
						}
					}

					if (e.keyCode == SWT.ARROW_DOWN) {
						time = new Integer(time.intValue() - 1);
						if (time.intValue() < 0) {
							textTime4.setText("999");
						} else {
							textTime4.setText(time.toString());
						}
					}
				} catch (NumberFormatException e2) {
					textTime4.setText("");
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
			public void keyReleased(KeyEvent e) {

			}
		});
		
		/*GUI related to width and precision*/
		//Create label for width and precision
		label = new Label(composite,SWT.NONE);
		label.setText(message5);
		GridData gridData10 = new GridData();
		gridData10.horizontalAlignment = GridData.BEGINNING;
		gridData10.horizontalSpan = 10;
		label.setLayoutData(gridData10);
		label.setFont(parent.getFont());
		
		//Create text box for width
		textWidth = new Text(composite, SWT.SINGLE | SWT.BORDER);
		textWidth.setTextLimit(4);
		textWidth.setText("");
		GridData gridData11 = new GridData();
		gridData11.widthHint = 20;
		gridData11.heightHint = 13;
		textWidth.setLayoutData(gridData11);
		textWidth.addKeyListener(new KeyListener() {
		public void keyPressed(KeyEvent e) {
			try {
				Integer time = new Integer(textWidth.getText());
			} catch (NumberFormatException e2) {
				if(textWidth.getText().indexOf(".")==-1){
					textWidth.setText("");
				}
			} catch (Exception e1) {
				e1.printStackTrace();
			}
		}

		public void keyReleased(KeyEvent e) {

		}
	});

		
		//Create label for hyphen
		Label hyphen = new Label(composite,SWT.NONE);
		hyphen.setText("-");
		
		//Create text box for precision
		textPrecision = new Text(composite,SWT.SINGLE | SWT.BORDER);
		textPrecision.setTextLimit(4);
		textPrecision.setText("");
		GridData gridData12 = new GridData();
		gridData12.widthHint = 20;
		gridData12.heightHint = 13;
		textPrecision.setLayoutData(gridData12);
		textPrecision.addKeyListener(new KeyListener() {
		public void keyPressed(KeyEvent e) {
			try {
				Integer time = new Integer(textPrecision.getText());
			} catch (NumberFormatException e2) {
				if(textPrecision.getText().indexOf(".")==-1){
					textPrecision.setText("");
				}
			} catch (Exception e1) {
				e1.printStackTrace();
			}
		}

		public void keyReleased(KeyEvent e) {

		}
	});

		
		//Create label for hysteresis window 
		Label hyst = new Label(composite,SWT.NONE);
		hyst.setText(message6);
		GridData gridData13 = new GridData();
		gridData13.horizontalAlignment= GridData.BEGINNING;
		gridData13.horizontalSpan = 10;
		hyst.setLayoutData(gridData13);
		hyst.setFont(parent.getFont());
		
		//Create text box for hysterisis window
		textHyst = new Text(composite,SWT.SINGLE | SWT.BORDER);
		textHyst.setTextLimit(5);
		textHyst.setText("");
		GridData gridData14 = new GridData();
		gridData14.widthHint = 18;
		gridData14.heightHint = 13;
		textHyst.setLayoutData(gridData14);
		textHyst.addKeyListener(new KeyListener() {
		public void keyPressed(KeyEvent e) {
			try {
				Integer time = new Integer(textHyst.getText());
			} catch (NumberFormatException e2) {
				if(textHyst.getText().indexOf(".")==-1){
					textHyst.setText("");
				}
			} catch (Exception e1) {
				e1.printStackTrace();
			}
		}

		public void keyReleased(KeyEvent e) {

		}
	});

		
		//Create label for general quantum
		Label qntm = new Label(composite,SWT.NONE);
		qntm.setText(message7);
		GridData gridData15 = new GridData ();
		gridData15.horizontalAlignment= GridData.BEGINNING;
		gridData15.horizontalSpan = 10;
		qntm.setLayoutData(gridData15);
		qntm.setFont(parent.getFont());
	
		//Create text box for general quantum
		textQntm = new Text(composite,SWT.SINGLE | SWT.BORDER);
		textQntm.setTextLimit(5);
		textQntm.setText("");
		GridData gridData16 = new GridData();
		gridData16.widthHint = 18;
		gridData16.heightHint = 13;
		textQntm.setLayoutData(gridData16);
		textQntm.addKeyListener(new KeyListener() {
		public void keyPressed(KeyEvent e) {
			try {
				Integer time = new Integer(textQntm.getText());
			} catch (NumberFormatException e2) {
				if(textQntm.getText().indexOf(".")==-1){
					textQntm.setText("");
				}
			} catch (Exception e1) {
				e1.printStackTrace();
			}
		}

		public void keyReleased(KeyEvent e) {

		}
	});


		return composite;
	}
	
	protected void createButtonsForButtonBar(Composite parent){
		// create OK and Cancel buttons by default
		simuButton =
			createButton(
				parent,
				IDialogConstants.PROCEED_ID,
				IDialogConstants.PROCEED_LABEL,
				true);
		simuButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {

				killButton.setEnabled(true);
				simuButton.setEnabled(false);
				doneButton.setEnabled(false);

			}
		});
		doneButton =
			createButton(
				parent,
				IDialogConstants.CLOSE_ID,
				IDialogConstants.CLOSE_LABEL,
				true);
				
		killButton =
			createButton(parent, IDialogConstants.STOP_ID, "Kill", true);
		killButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				simuProcess.destroy();
				try {
					//"ps" allows one to view the process table in linux/cygwin ('-W' parameter allows one to view windows' processes as well!)					
					Process lookProcess = Runtime.getRuntime().exec("ps");
					BufferedReader bf =
						new BufferedReader(
							new InputStreamReader(
								lookProcess.getInputStream()));
					String msg = null;
					while ((msg = bf.readLine()) != null) {
						//looks for simu/simuOrig at the end of path portion of line to find process
						if (msg.endsWith("cd++")) {
							msg = msg.substring(2).trim();
							Process killProcess =
								Runtime.getRuntime().exec(
									"kill -9 "
										+ msg.substring(0, msg.indexOf(" ")));
						}

					}
				} catch (IOException e1) {

					e1.printStackTrace();
				}
				doneButton.setEnabled(true);
				killButton.setEnabled(false);
				simuButton.setEnabled(true);
				simuKilled = true;

			}
		});
		killButton.setEnabled(false);



	}
	
	protected void buttonPressed(int buttonId){
		String combine = "";
		if (buttonId == IDialogConstants.CLOSE_ID) {
			ok2Close = true;
			close();
		}
		
		if (buttonId == IDialogConstants.PROCEED_ID) {

			combine = collectParameters();
			if (combine == null) {
				return;
			}
			if(isFieldEmpty){
				MessageBox info = new MessageBox(parent,SWT.ICON_INFORMATION);
				info.setText("Missing information");
				info.setMessage("Default values will be used for fields left empty.");
				info.open();
			}
			System.out.println("combine: " + combine);
			RunSimuModelica rsimu = new RunSimuModelica(textRoot.getText(),combine, this);
			rsimu.start();

		}
		
		super.buttonPressed(buttonId);
	}
	private String collectParameters(){
		
		String[] param = new String[8];
		//check to see if user
		//forgot to select root folder
		if(isEmpty("Eclipse root folder",textRoot)){
			return null;
		}

		//check to see if user
		//forgot to enter *.mo file
		if(isEmpty("Modelica (*.mo)",textMo)){
			return null;
		}
		
		/*Store all parametes in a String array*/
		
		//Stop Time
		if(textTime1.getText().equals("00") && textTime2.getText().equals("00") 
		&& textTime3.getText().equals("00") && textTime4.getText().equals("000")){
			param[0]="";
			//a field left empty
			isFieldEmpty = true;
		}
		
		else{
		param[0] = "-t "+textTime1.getText()+":"+textTime2.getText()+":"
						+textTime3.getText()+":"+textTime4.getText();
		}
		//Width and precision	
		if(textWidth.getText().equals("") || textPrecision.getText().equals("")){
			//a field left empty
			isFieldEmpty = true;
			param[1] = "";					
		}
		else{
		param[1] = " -w "+textWidth.getText()+"-"+textPrecision.getText();
		}
        
		//path for log file with quotes and back-slashes
		//replaced with forward-slashes
		if(textLog.getText().equals("")){
			//a field left empty
			isFieldEmpty = true;
			param[2] = "";
		}
		else{
		String param2 = textLog.getText();
		param2 = param2.replace('\\','/');
		param[2] = " -l "+"\""+param2+"\"";
		}
			
		//path for output directory with quotes, and back-slashes
		//replaced with forward-slashes (for cygwin)
		if(textOutDir.getText().equals("")){
			//a field left empty
			isFieldEmpty = true;
			param[3]="";
		}
		else{
		String param3 = textOutDir.getText();
		param3 = param3.replace('\\','/');	
		param[3] = " -o "+"\""+param3+"\"";
		}
		
		if(textQntm.getText().equals("")){
			//a field left empty
			isFieldEmpty = true;
			param[4] = "";
		}
		else{
		param[4] = " -q "+textQntm.getText();
		}
		
		if(textHyst.getText().equals("")){
			//a field left empty
			isFieldEmpty = true;	
			param[5] = "";
		}
		else{
			param[5] = " -y "+textHyst.getText();
		}
		
		//path for configuration file with quotes, and back-slashes
		//replaced with forward-slashes (for cygwin)
		if(textConfig.getText().equals("")){
			//a field left empty
			isFieldEmpty = true;
			param[6] = "";
		}
		else{
		String param6 = textConfig.getText();
		param6 = param6.replace('\\','/');	
		param[6] = " -f "+"\""+param6+"\"";
		}
		
		//path for *.mo file with **NO QUOTES** (otherwise it doesn't work) , and back-slashes
		//replaced with forward-slashes (for cygwin)
		String param7 = textMo.getText();
		param7 = param7.replace('\\','/');
		param[7] = " "+param7;

		
		 //Converting the array into a string of characters
		 String allParams="";
		 for(int n=0;n<param.length;n++){
			allParams+=param[n];
		 }
		
		return allParams;	
	}
	public boolean close (){
		if(ok2Close){
			return super.close();
		}
		return true;
	}
	
	class conWrite implements Runnable {
		String line;
		public conWrite(String line) {
			this.line = line;
		}
		public void run() {
			ConsoleDocument.getCDOS().set(line);
		}
	}
	
	class RunSimuModelica extends Thread{
		private Dialog d;
		private String command;
		private String rootFolder;
		public RunSimuModelica(String rootFolder, String command, Dialog d) {
			this.command = command;
			this.rootFolder = rootFolder;
			this.d = d;
		}
		
		public void run(){
			
			try{
			
			IPath path = new Path (rootFolder+"\\plugins\\CD++Builder_1.1.0\\internal\\");
			File a = new File("C:\\tempSimuModelica.bat");
			FileWriter tempFile = new FileWriter(a);
			tempFile.write("cd "+"\""+path.toString()+"mcd++"+"\""+"\n"+"./mcd++ " + command);
			tempFile.close();
			runCygwin = Runtime.getRuntime().exec("bash "+"C:\\tempSimuModelica.bat");//+path+"tempSimuModelica.bat",null,new File(path.toString()));
			StreamHandler outputHandler =
				new StreamHandler(
					runCygwin.getInputStream(),
					"OUTPUT",
					true);

			StreamHandler errorHandler =
				new StreamHandler(
					runCygwin.getErrorStream(),
					"ERROR",
					true);

			outputHandler.start();
			errorHandler.start();

			int exitVal = runCygwin.waitFor();
			a.delete();
			Display.getDefault().syncExec(new Runnable() {
				public void run() {
					doneButton.setEnabled(true);
					killButton.setEnabled(false);
					simuButton.setEnabled(true);
					d.close();
				}
			});
			
			if (simuKilled) {

				Display.getDefault().syncExec(
					new conWrite(
						"***User has killed the simulation***" + "\n"));
				simuKilled = false;

			}


			}
			catch(Exception e){
				e.printStackTrace();
				System.out.println("Balle Balle shera!!!!");
			}
		}
	}
	
//utility (helper) methods for creating labels

	private Label createLabel(Composite parent, Composite composite, String message) {
		Label label = new Label(composite, SWT.NONE);
		label.setText(message);
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.horizontalSpan=10;		
		label.setLayoutData(gridData);
		label.setFont(parent.getFont());
		return label;
	}
	
	private String NewFileGui(String filter) {	
	
		FileDialog fileDialog = new FileDialog(parent);
		String[] extention = new String[1];
		extention[0] = filter;
		fileDialog.setFilterPath("C:");
		fileDialog.setFilterExtensions(extention);
		fileDialog.open();
		System.out.println("Path"+fileDialog.getFilterPath());
		
		return fileDialog.getFilterPath() + "\\" + fileDialog.getFileName();
	}
	
	private String newDirGui (){
		DirectoryDialog dirDialog = new DirectoryDialog(parent);
		dirDialog.setFilterPath("C:");
		return dirDialog.open();
	}
	
	private boolean isEmpty(String parameter, Text textBox) {
		String value = textBox.getText();
		if (value.length() == 0) {

			MessageBox mbox =
				new MessageBox(parent, SWT.ICON_ERROR | SWT.OK |SWT.APPLICATION_MODAL);
			mbox.setText("Error");
			mbox.setMessage(parameter + " not selected");
			mbox.open();

			composite.setEnabled(true);
			doneButton.setEnabled(true);
			killButton.setEnabled(false);
			simuButton.setEnabled(true);
			ok2Close = true;
			//removed the mbox.wait(); 
			//along with the try-catch block so that now the msg box works correctly now

			doneButton.setEnabled(true);
			killButton.setEnabled(false);
			simuButton.setEnabled(true);
			return true;
		}
		return false;
	}

	

}